﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CtorNameLeakingInExceptions {

	class A {
		private int x = 5;

		public A() {
			Console.WriteLine($"A(): x == {x} (note .ctor below)");
			throw new NotImplementedException();
		}
	}

	class B {
		public static int y = 6;

		static B() {
			Console.WriteLine($"static B(): y == {y} (note .cctor below)");
			throw new NotImplementedException();
		}
	}

	class Program {
		static void Main(string[] args) {
			try {
				new A();
			} catch (Exception ex) {
				Console.WriteLine(ex);
			}

			Console.WriteLine();

			try {
				Console.WriteLine(B.y);
			} catch (Exception ex) {
				Console.WriteLine(ex);
			}
		}
	}
}
